
function deviceCtxSession() {
	var sessionRandom = Math.floor((1 << 24) * Math.random());
	var sessionTimestamp = new Date().getTime();
	return sessionRandom + '' + sessionTimestamp;
}

function subString(str, start, end) {
	return str.substring(start,end);
}

function getTimeStr() {
	var serverTime = new Date();
	var time_str = serverTime.formatWithTimezone("yyyyMMddhhmmss", 8);
	return time_str;
}

function getTimeNow() {
	var time = new Date();
	return time.getTime() + '';
}

function timeLast(time, offset) {
	var now = new Date();
	var last = now.getTime() - time;
	if(last > offset) {
		return '1';
	}
	return '0';
}

function preDate(datestr) {
	var yesterday = Date.parse(datestr);
	var yesterday_milliseconds = yesterday.getTime() - 1000 * 60 * 60 * 24;
	yesterday.setTime(yesterday_milliseconds);

	var strYear = yesterday.getFullYear();
	var strDay = yesterday.getDate();
	var strMonth = yesterday.getMonth() + 1;
	if (strMonth < 10) {
		strMonth = "0" + strMonth;
	}
	datastr = strYear + "-" + strMonth + "-" + strDay;
	return datastr;
}

function getYestoday() {
	var yesterday = new Date();
	var yesterday_milliseconds = yesterday.getTime() - 1000 * 60 * 60 * 24;
	yesterday.setTime(yesterday_milliseconds);

	var strYear = yesterday.getFullYear();
	var strDay = yesterday.getDate();
	var strMonth = yesterday.getMonth() + 1;
	if (strMonth < 10) {
		strMonth = "0" + strMonth;
	}
	datastr = strYear + "-" + strMonth + "-" + strDay;
	return datastr;
}

function getTimeOffset(serverTime) {
	var d = new Date(serverTime);
	return Date.now() - d;
}

function getX() {
	return Math.random();
}

function getPassengerStatus(passenger_id_type_code, total_times) {
	var j = total_times;
	var h = "待核验";
	if (passenger_id_type_code == "2") {
		h = "未通过";
	} else {
		if (j == "95" || j == "97") {
			h = "已通过";
		} else {
			if (j == "93" || j == "99") {
				if (passenger_id_type_code == "1") {
					h = "已通过";
				} else {
					h = "预通过";
				}
			} else {
				if (j == "94" || j == "96") {
					if (passenger_id_type_code == "1") {
						h = "未通过";
					} else {
						h = "未通过";
					}
				} else {
					if (j == "92" || j == "98") {
						if (passenger_id_type_code == "B" || passenger_id_type_code == "C" || passenger_id_type_code == "G") {
							h = '请报验';
						} else {
							h = '待核验';
						}
					} else {
						if (j == "91") {
							if (passenger_id_type_code == "B" || passenger_id_type_code == "C" || passenger_id_type_code == "G") {
								h = '请报验';
							}
						} else {
							h = '请报验';
						}
					}
				}
			}
		}
	}
	return h;
}

function paserCacheData(ypinfo, yp_ex) {
	var seatsType = serverCache;
	for (var i = 0; i < seatsType.length; i++) {
		seatTypeMap[seatsType[i].seat_type_code] = seatsType[i].seat_type_name;
	}
	return processYpInfo(ypinfo, yp_ex);
}

function validateData(ypinfo) {
    var arrayLength = ypinfo.length / 10;
    for (var i = 0, m = 6, n = 10, x = 0, y = 1; i < arrayLength; i++, m = m + 10, n = n + 10, x = x + 10, y = y + 10) {
        if ((parseFloat(ypinfo.substring(y, m), 10) / 10) < 0.1) {
            return '0';
        }
    }
    return '1';
}

var deviceModels = new Array("Galaxy Nexus", "samsung GT-I9001", "MOT MT788", "samsung GT-I9508");

function getDeviceModel() {
	var rand = parseInt(Math.random() * deviceModels.length);
	return deviceModels[rand];
}

var seatTypeMap = new Array();
var serverCache = [
		{
			"seat_type_name" : "棚车",
			"seat_type_code" : "0"
		}, 
		{
			"seat_type_name" : "硬座",
			"seat_type_code" : "1"
		}, 
		{
			"seat_type_name" : "软座",
			"seat_type_code" : "2"
		}, 
		{
			"seat_type_name" : "硬卧",
			"seat_type_code" : "3"
		}, 
		{
			"seat_type_name" : "软卧",
			"seat_type_code" : "4"
		}, 
		{
			"seat_type_name" : "包厢硬卧",
			"seat_type_code" : "5"
		}, 
		{
			"seat_type_name" : "高级软卧",
			"seat_type_code" : "6"
		}, 
		{
			"seat_type_name" : "一等软座",
			"seat_type_code" : "7"
		}, 
		{
			"seat_type_name" : "二等软座",
			"seat_type_code" : "8"
		}, 
		{
			"seat_type_name" : "商务座",
			"seat_type_code" : "9"
		}, 
		{
			"seat_type_name" : "高级动卧",
			"seat_type_code" : "A"
		}, 
		{
			"seat_type_name" : "混编硬座",
			"seat_type_code" : "B"
		}, 
		{
			"seat_type_name" : "混编硬卧",
			"seat_type_code" : "C"
		}, 
		{
			"seat_type_name" : "包厢软座",
			"seat_type_code" : "D"
		}, 
		{
			"seat_type_name" : "特等软座",
			"seat_type_code" : "E"
		}, 
		{
			"seat_type_name" : "动卧",
			"seat_type_code" : "F"
		}, 
		{
			"seat_type_name" : "二人软包",
			"seat_type_code" : "G"
		}, 
		{
			"seat_type_name" : "一人软包",
			"seat_type_code" : "H"
		}, 
		{
			"seat_type_name" : "一等双软",
			"seat_type_code" : "I"
		}, 
		{
			"seat_type_name" : "二等双软",
			"seat_type_code" : "J"
		}, 
		{
			"seat_type_name" : "混编软座",
			"seat_type_code" : "K"
		}, 
		{
			"seat_type_name" : "混编软卧",
			"seat_type_code" : "L"
		}, 
		{
			"seat_type_name" : "一等座",
			"seat_type_code" : "M"
		}, 
		{
			"seat_type_name" : "二等座",
			"seat_type_code" : "O"
		}, 
		{
			"seat_type_name" : "特等座",
			"seat_type_code" : "P"
		}, 
		{
			"seat_type_name" : "观光座",
			"seat_type_code" : "Q"
		}, 
		{
			"seat_type_name" : "一等包座",
			"seat_type_code" : "S"
		}
];
var seatTypeRateMap = {
	"0" : 41,
	"1" : 23,
	"2" : 22,
	"3" : 21,
	"4" : 20,
	"5" : 40,
	"6" : 18,
	"7" : 24,
	"8" : 25,
	"9" : 10,
	"A" : 26,
	"B" : 27,
	"C" : 28,
	"D" : 29,
	"E" : 30,
	"F" : 31,
	"G" : 32,
	"H" : 33,
	"I" : 34,
	"J" : 35,
	"K" : 36,
	"L" : 37,
	"M" : 14,
	"O" : 16,
	"P" : 12,
	"Q" : 38,
	"S" : 39
};

function processYpInfo(ypinfo, yp_ex) {
	var arrayLength = ypinfo.length / 10;
	var obj = new Array();
	var temp_seat_rate = 50; // 对于没有定义的座位，rate值从50开始递增
	for (var i = 0, m = 6, n = 10, x = 0, y = 1; i < arrayLength; i++, m = m + 10, n = n + 10, x = x + 10, y = y + 10) {
		var seat_type_id = ypinfo.substring(x, y);
		var seat_type = null;
		var seat_type_rate = null;
		var seat_num = 0;
		if (parseInt(ypinfo.substring(m, m + 1), 10) >= 3) {
			seat_type = "无座";
			seat_type_rate = 100;
			seat_num = parseInt(ypinfo.substring(m, n), 10) - 3000;
		} else {
			seat_type = seatTypeMap[seat_type_id];
			seat_type_rate = seatTypeRateMap[seat_type_id];
			if (seat_type_rate === null || seat_type_rate === "undefined") {
				seat_type_rate = temp_seat_rate;
				temp_seat_rate = temp_seat_rate + 1;
			}
			seat_num = parseInt(ypinfo.substring(m, n), 10);
		}

		obj[i] = {
			type_id : seat_type_id,
			type : seat_type,
			type_rate : seat_type_rate, // 保存座位rate用于排序
			num : seat_num,
			uclass : getLiClass(i),
			price : (parseFloat(ypinfo.substring(y, m), 10) / 10)
			.toFixed(2)
		};
	}
	processYpEx(obj, yp_ex);
	var sortedObjs = sortYpInfo(obj);

	for (var i = 0; i < sortedObjs.length; i++) {
		sortedObjs[i].uclass = getLiClass(i);
	}
	
	//sortedObjs = repalceYpInfoType(sortedObjs);
	return json2str(sortedObjs);
}

function processYpEx(yplist, yp_ex) {
	//席别折扣判断
	for(var k=0;k<yplist.length;k++){
		yplist[k].discount = "0";
		 if (yp_ex&&yp_ex.length > 0) {
			 for(var di = 0;di<yp_ex.length;di=di+2){
				 if(yp_ex.substr(di+1,1) === '1'){
					 if(yp_ex.substr(di,1) == yplist[k].type_id){
						 yplist[k].discount = "1";
					 }
				 }
			 }
		 }else{
			 yplist[k].discount = '0';
		 }
	}
};

function json2str(o) {
	var arr = [];
	var fmt = function (s) {
		if (typeof s == 'object' && s != null)
			return json2str(s);
		return /^(string|number)$/.test(typeof s) ? "'" + s + "'" : s;
	}
	for (var i in o)
		arr.push("'" + i + "':" + fmt(o[i]));
	return '{' + arr.join(',') + '}';
}

// 按照座位的type_rate进行排序，规则如下
// 商务座、特等座、一等座、二等座、高级软卧、软卧、硬卧、软座、硬座、（...）、无座 的顺序显示；
// 如果出现其余席别，显示在这些席别的后面，顺序暂不限，其中 无座 总放在最后面。
function sortYpInfo(ypinfoArray) {

	var by = function (name) {
		return function (o, p) {
			var a,
			b;
			if (typeof o === "object" && typeof p === "object" && o && p) {
				a = o[name];
				b = p[name];
				if (a === b) {
					return 0;
				}
				if (typeof a === typeof b) {
					return a < b ? -1 : 1;
				}
				return typeof a < typeof b ? -1 : 1;
			} else {
				throw("error");
			}
		};
	};

	ypinfoArray.sort(by("type_rate"));
	return ypinfoArray;

}

function getLiClass(index) {
	switch (index % 4) {
	case 0:
		return "ui-block-a";
	case 1:
		return "ui-block-b";
	case 2:
		return "ui-block-c";
	case 3:
		return "ui-block-d";
	default:
		return "ui-block-e";

	}
}

// 把两个字数以上的座位类型改为两位
function repalceYpInfoType(objs) {
	for (var i in objs) {
		var type = objs[i].type;
		switch (type) {
		case "商务座":
			objs[i].type = "商务";
			break;
		case "特等座":
			objs[i].type = "特等";
			break;
		case "一等座":
			objs[i].type = "一等";
			break;
		case "二等座":
			objs[i].type = "二等";
			break;
		case "高级软卧":
			objs[i].type = "高软";
			break;
		case "观光座":
			objs[i].type = "观光";
			break;
		}
	}
	return objs;
};
var Base32 = new function () {
	var delta = 0x9E3779B8;
	function longArrayToString(data, includeLength) {
		var length = data.length;
		var n = (length - 1) << 2;
		if (includeLength) {
			var m = data[length - 1];
			if ((m < n - 3) || (m > n))
				return null;
			n = m;
		}
		for (var i = 0; i < length; i++) {
			data[i] = String.fromCharCode(data[i] & 0xff, data[i] >>> 8 & 0xff, data[i] >>> 16 & 0xff, data[i] >>> 24 & 0xff);
		}
		if (includeLength) {
			return data.join('').substring(0, n);
		} else {
			return data.join('');
		}
	};
	function stringToLongArray(string, includeLength) {
		var length = string.length;
		var result = [];
		for (var i = 0; i < length; i += 4) {
			result[i >> 2] = string.charCodeAt(i) | string.charCodeAt(i + 1) << 8 | string.charCodeAt(i + 2) << 16 | string.charCodeAt(i + 3) << 24;
		}
		if (includeLength) {
			result[result.length] = length;
		}
		return result;
	};
	this.encrypt = function (string, key) {
		if (string == "") {
			return "";
		}
		var v = stringToLongArray(string, true);
		var k = stringToLongArray(key, false);
		if (k.length < 4) {
			k.length = 4;
		}
		var n = v.length - 1;
		var z = v[n],
		y = v[0];
		var mx,
		e,
		p,
		q = Math.floor(6 + 52 / (n + 1)),
		sum = 0;
		while (0 < q--) {
			sum = sum + delta & 0xffffffff;
			e = sum >>> 2 & 3;
			for (p = 0; p < n; p++) {
				y = v[p + 1];
				mx = (z >>> 5^y << 2) + (y >>> 3^z << 4)^(sum^y) + (k[p & 3^e]^z);
				z = v[p] = v[p] + mx & 0xffffffff;
			}
			y = v[0];
			mx = (z >>> 5^y << 2) + (y >>> 3^z << 4)^(sum^y) + (k[p & 3^e]^z);
			z = v[n] = v[n] + mx & 0xffffffff;
		}
		return longArrayToString(v, false);
	};
};

function bin216(s) {
	var i,
	l,
	o = "",
	n;
	s += "";
	b = "";
	for (i = 0, l = s.length; i < l; i++) {
		b = s.charCodeAt(i);
		n = b.toString(16);
		o += n.length < 2 ? "0" + n : n;
	}
	return o;
};

var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
function encode32(input) {
	input = escape(input);
	var output = "";
	var chr1,
	chr2,
	chr3 = "";
	var enc1,
	enc2,
	enc3,
	enc4 = "";
	var i = 0;
	do {
		chr1 = input.charCodeAt(i++);
		chr2 = input.charCodeAt(i++);
		chr3 = input.charCodeAt(i++);
		enc1 = chr1 >> 2;
		enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
		enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
		enc4 = chr3 & 63;
		if (isNaN(chr2)) {
			enc3 = enc4 = 64;
		} else if (isNaN(chr3)) {
			enc4 = 64;
		}
		output = output + keyStr.charAt(enc1) + keyStr.charAt(enc2) + keyStr.charAt(enc3) + keyStr.charAt(enc4);
		chr1 = chr2 = chr3 = "";
		enc1 = enc2 = enc3 = enc4 = "";
	} while (i < input.length);
	return output;
};

function loginvalueforkey(key) {
	return encode32(bin216(Base32.encrypt("1111", key)));
};
